package com.dsic.gj_erp;

import com.github.jeffreyning.mybatisplus.conf.EnableMPP;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.Session;
import com.querydsl.jpa.impl.JPAQueryFactory;
import org.modelmapper.ModelMapper;
import org.modelmapper.convention.MatchingStrategies;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.autoconfigure.jdbc.DataSourceTransactionManagerAutoConfiguration;
import org.springframework.boot.autoconfigure.orm.jpa.HibernateJpaAutoConfiguration;
import org.springframework.context.annotation.Bean;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.transaction.annotation.EnableTransactionManagement;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

import javax.annotation.PostConstruct;
import javax.persistence.EntityManager;
import java.util.Properties;

@EnableAsync
@EnableMPP
@SpringBootApplication(exclude = {
        DataSourceAutoConfiguration.class} )
@EnableSwagger2
@EnableTransactionManagement
public class GjErpApplication {

    public static void main(String[] args) {
//        new GjErpApplication().init();
        SpringApplication.run(GjErpApplication.class, args);
    }
    @Bean
    public JPAQueryFactory jpaQueryFactory(EntityManager entityManager){
        return new JPAQueryFactory(entityManager);
    }

    @Bean
    public ModelMapper modelMapper() {
        ModelMapper modelMapper = new ModelMapper();
        /**
         * 完全匹配
         */
        modelMapper.getConfiguration().setFullTypeMatchingRequired(true);
        /**
         * 匹配策略定义为严格
         */
        modelMapper.getConfiguration().setMatchingStrategy(MatchingStrategies.STRICT);
        return modelMapper;
    }

    private static Session session;

//    @PostConstruct
    public void init() {
        System.out.println(1111);
        JSch jsch = new JSch();
        Thread thread = new Thread(() -> {
            try {
                session = jsch.getSession("root", "43.143.202.126", 22);
                jsch.addIdentity("E:\\文档\\润芃\\腾讯云服务器\\43.143.202.126\\Runpeng666.pem");
                Properties config = new Properties();
                config.put("StrictHostKeyChecking", "no");
                session.setConfig(config);
                session.connect();
                session.setPortForwardingL(10005, "127.0.0.1", 10005);
                System.out.println(session.isConnected());
            } catch (JSchException e) {
                e.printStackTrace();
            }
        });
        thread.start();
    }
}
