package com.dsic.gj_erp.controller.jhgk;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.bean.copier.CopyOptions;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.EasyExcel;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmCbxxp;
import com.dsic.gj_erp.bean.jcsj.EmSbjgry;
import com.dsic.gj_erp.bean.jhgk.DmQfxq;
import com.dsic.gj_erp.bean.jhgk.excel.GdxqExcel;
import com.dsic.gj_erp.bean.jhgk.excel.GdxqExcel1;
import com.dsic.gj_erp.bean.jhgk.excel.QfExcel;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.listeners.ExcelGdxq1Listener;
import com.dsic.gj_erp.listeners.ExcelGdxqListener;
import com.dsic.gj_erp.listeners.ExcelQFListener;
import com.dsic.gj_erp.service.jcsj.DmCbxxpService;
import com.dsic.gj_erp.service.jhgk.DmQfxqService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-18
 */
@RestController
@RequestMapping("/dmQfxq")
public class DmQfxqController {

    @Autowired
    DmQfxqService service;
    @Autowired
    DmCbxxpService cbxxpService;

    //查询
    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody DmQfxq qfxq) {
        List<DmQfxq> list = service.list(new QueryWrapper<DmQfxq>()
                .eq(StrUtil.isNotEmpty(qfxq.getDcCh()), "dc_ch", qfxq.getDcCh())
                .eq(StrUtil.isNotEmpty(qfxq.getXzglxq()), "substring(Xzglxq,0,8) ", qfxq.getXzglxq())
                .eq(StrUtil.isNotEmpty(qfxq.getZt()), "zt", qfxq.getZt())
                .orderByAsc("DC_CH,cast(dc_pl as int),DC_FD"));
        return new ResultBean(list);
    }

    @RequestMapping("/getCzxx")
    @AuthFunction
    public ResultBean getCzxx() {
        List<DmCbxxp> list = cbxxpService.list(new QueryWrapper<DmCbxxp>()
                .select("cbbm", "cbmc")
                .eq("wgbs", "N")
                .orderBy(true, true, "cbbm"));
        return new ResultBean(list);
    }

    //导入
    @PostMapping("/upload")
    @AuthFunction
    @ResponseBody
    public ResultBean uploadQf(@RequestParam("file") MultipartFile file, HttpServletRequest req) throws Exception, CustomException {

        ExcelGdxqListener objectListener = new ExcelGdxqListener();
        ExcelGdxq1Listener objectListener1 = new ExcelGdxq1Listener();

        EasyExcel.read(file.getInputStream(), GdxqExcel.class, objectListener).sheet(0).headRowNumber(1).doRead();
        List<GdxqExcel> objList = objectListener.getObjectList();

        EasyExcel.read(file.getInputStream(), GdxqExcel1.class, objectListener1).sheet(1).headRowNumber(1).doRead();
        List<GdxqExcel1> objList1 = objectListener1.getObjectList();


        List<DmQfxq> list = BeanUtil.copyToList(objList, DmQfxq.class);
        List<DmQfxq> list1 = BeanUtil.copyToList(objList1, DmQfxq.class);
        String username=(String) req.getAttribute("yhms");
        String day= DateUtil.format(DateUtil.date(), "yyyy/MM/dd");
         list= service.saveXzList(list,username,day);
         List<DmQfxq> list2=new ArrayList<>(list);
        if (list1.size()>0){
            list1= service.saveDzList(list1,username,day);
            for (DmQfxq qfxq : list1) {//循环大组
                for (DmQfxq dmQfxq : list) {//循环小组
                    if (qfxq.getId().equals(dmQfxq.getId())){//小组有
                       int index= list.indexOf(dmQfxq);
                        list2.set(index,qfxq);
                       break;
                    }
                }
                list2.add(qfxq);
            }
        }
        service.generateYdjh(list2);

        return new ResultBean(list2);
    }

    //保存
    @RequestMapping("/save")
    @AuthFunction
    public ResultBean save(@RequestBody List<DmQfxq> qfxqs) {
        service.saveBatch(qfxqs);
        return new ResultBean();
    }

    //删除
    @RequestMapping("/remove")
    @AuthFunction
    public ResultBean remove(@RequestBody List<DmQfxq> qfxqs) {
        List<String> idList=qfxqs.stream().map(DmQfxq::getId).collect(Collectors.toList());
        service.removeByIds(idList);
        return new ResultBean();
    }

    //提交/退回
    @RequestMapping("/qfxqTJ")
    @AuthFunction
    public ResultBean qfxqTJ(@RequestBody List<DmQfxq> qfxqs) {
        qfxqs.forEach(q -> {
            if (q.getZt().equals("0")) {
                q.setZt("1");
                return;
            }
            if (q.getZt().equals("1")) {
                q.setZt("0");
            }
        });
        service.updateBatchById(qfxqs);
        return new ResultBean();
    }

    //审核
    @RequestMapping("/qfxqSH")
    @AuthFunction
    public ResultBean qfxqSH(@RequestBody List<DmQfxq> qfxqs) {
        qfxqs.forEach(q -> {
            if (q.getZt().equals("1")) {
                q.setZt("2");
            }
        });
        service.updateBatchById(qfxqs);
        return new ResultBean();
    }


}
