package com.dsic.gj_erp.controller.jhgk;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.EasyExcel;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmQfxq;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.bean.jhgk.excel.GdxqExcel;
import com.dsic.gj_erp.bean.jhgk.excel.GdxqExcel1;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.listeners.ExcelGdxq1Listener;
import com.dsic.gj_erp.listeners.ExcelGdxqListener;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import com.dsic.gj_erp.service.jhgk.DmSygdxqService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import springfox.documentation.spring.web.json.Json;

import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-02
 */
@RestController
@RequestMapping("/dmSygdxq")
public class DmSygdxqController {

    @Autowired
    private DmSygdxqService service;
    @Autowired
    private DmSygdMxService sygdMxService;
    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody Map<String, String> map) {

        List<DmSygdxq> list = service.list(new QueryWrapper<DmSygdxq>()
                        .eq(StrUtil.isNotEmpty(map.get("dcCh")),"dc_ch",map.get("dcCh"))
                .ge(StrUtil.isNotEmpty(map.get("beginTime")), "xzglxq", DateUtil.beginOfMonth(DateUtil.parseDate(map.get("beginTime"))))
                .le(StrUtil.isNotEmpty(map.get("endTime")), "xzglxq", DateUtil.endOfMonth(DateUtil.parseDate(map.get("endTime"))))
//                .orderByAsc("dc_ch, cast(dc_pl as int),xzglxq"));
                .orderByAsc("dc_ch, dc_pl,xzglxq"));
        return new ResultBean(list);
    }

    @PostMapping("/upload")
    @AuthFunction
    @ResponseBody
    public ResultBean uploadQf(@RequestParam("file") MultipartFile file, HttpServletRequest req) throws Exception, CustomException {

        ExcelGdxqListener objectListener = new ExcelGdxqListener();
        ExcelGdxq1Listener objectListener1 = new ExcelGdxq1Listener();

        EasyExcel.read(file.getInputStream(), GdxqExcel.class, objectListener).sheet(0).headRowNumber(1).doRead();
        List<GdxqExcel> objList = objectListener.getObjectList();

        EasyExcel.read(file.getInputStream(), GdxqExcel1.class, objectListener1).sheet(1).headRowNumber(1).doRead();
        List<GdxqExcel1> objList1 = objectListener1.getObjectList();
        List<DmSygdxq> list = BeanUtil.copyToList(objList, DmSygdxq.class);
        List<DmSygdxq> list1 = BeanUtil.copyToList(objList1, DmSygdxq.class);

        String username=(String) req.getAttribute("yhms");
        String day=DateUtil.format(DateUtil.date(), "yyyy/MM/dd");
        service.saveXzList(list,username,day);
        service.saveDzList(list1,username,day);

        return new ResultBean();
    }



}

