package com.dsic.gj_erp.controller.kban;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmBzry;
import com.dsic.gj_erp.bean.jcsj.DmCbxxp;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.service.jcsj.DmBzryService;
import com.dsic.gj_erp.service.jcsj.DmCbxxpService;
import com.dsic.gj_erp.service.zyjh.ZyjhService;
import com.google.common.collect.ImmutableMap;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("kban")
@AllArgsConstructor
public class KbanController {

    private final ZyjhService zyjhService;
    private final DmBzryService cqService;

    /**
     * 在建船只,各船只进度
     */
    @GetMapping("gcjd")
    public ResultBean<?> gcjd(){
        return new ResultBean<>(zyjhService.gcjd());
    }

    /**
     * 各垮计划完成情况
     */
    @GetMapping("gxjhwcqk")
    public ResultBean<?> gxjhwcqk(){
        List<Map<String, Object>> gxjhwcqk = zyjhService.gxjhwcqk();
        return new ResultBean<>(gxjhwcqk);
    }

    /**
     * 各月份产量(吨)
     */
    @GetMapping("gyfcl")
    public ResultBean<?> gyfcl(){
        return new ResultBean<>(zyjhService.gyfcl());
    }

    /**
     * 计划完成情况(吨)
     */
    @GetMapping("jhwcqk")
    public ResultBean<?> jhwcqk(){
        return new ResultBean<>(zyjhService.jhwcqk());
    }

    /**
     * 各垮产量
     */
    @GetMapping("gekuachaliang")
    public ResultBean<?> gekuachaliang(){
        return new ResultBean<>(zyjhService.gekuachaliang());
    }

    /**
     * 考勤情况
     */
    @GetMapping("kq")
    public ResultBean<?> kq(){
        List<DmBzry> ryList=cqService.list(Wrappers.<DmBzry>lambdaQuery()
                .isNotNull(DmBzry::getUserCode).isNotNull(DmBzry::getZt));

        Map<String,Object> map=new HashMap<>();
        map.put("total",ryList.size());
        map.put("rows",ryList);
        return new ResultBean<>(map);
    }
}
