package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.*;
import com.dsic.gj_erp.bean.jhgk.DmTzjh;
import com.dsic.gj_erp.bean.pgd.PgdTzjh;
import com.dsic.gj_erp.bean.sy.Dm_zhbmp;
import com.dsic.gj_erp.bean.zyjh.Ycldw;
import com.dsic.gj_erp.dao.sy.Dm_zhbmpRepository;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.jcsj.*;
import com.dsic.gj_erp.service.jcsj.impl.DmDwxxpService;
import com.dsic.gj_erp.service.pgd.PgdTzjhService;
import com.dsic.gj_erp.service.sy.SYService;
import com.dsic.gj_erp.service.zyjh.YcldwService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@RestController
@RequestMapping("/pgdTzjh")
public class PgdTzjhController {

    @Autowired
    PgdTzjhService pgdTzjhService;

    @Autowired
    DmCbxxpService dmCbxxpService;

    @Autowired
    EmSbjgryService emSbjgryService;

    @Autowired
    DmDwxxpService dwxxpService;
    @Autowired
    YcldwService ycldwService;
    @Autowired
    Dm_zhbmpRepository dm_zhbmpRepository;


    @Autowired
    DmBzryService dmBzryService;


    @Autowired
    SYService syService;



    /**
     * 检查板材领取表,套料图是否导入,如果已经导入更新图纸计划为已反馈
     * @param list
     * @return
     */
    @AuthFunction
    @PostMapping("checkTz")
    public ResultBean<?> checkTz(@RequestBody List<PgdTzjh> list,HttpServletRequest request){
        String username= (String) request.getAttribute("yhms");
        pgdTzjhService.updateForCheck(list,username);
        return new ResultBean<>();
    }



    @PostMapping("/getTzjhPgd")
    @ResponseBody
    public ResultBean getTzjhPgd(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
        QueryWrapper <PgdTzjh> qw =new QueryWrapper<>();


        qw.eq(StrUtil.isNotEmpty((String)map.get("dcch")),"czbh",(String)map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("pl")),"pl",(String)map.get("pl"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("fd")),"fd",(String)map.get("fd"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("zt")),"zt",(String)map.get("zt"));
        qw.orderBy(true,true,"czbh","pl","fd");
        return new ResultBean(pgdTzjhService.list(qw));

    }

    @PostMapping("/saveTzjhPgdXd")
    @ResponseBody
    @AuthFunction
    public ResultBean saveTzjhPgdXd(HttpServletRequest req, @RequestBody List<PgdTzjh>list) throws Exception, CustomException {
        pgdTzjhService.saveTzjhPgdXd(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveTzjhPgdXdBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveTzjhPgdXdBack(HttpServletRequest req, @RequestBody List<PgdTzjh>list) throws Exception, CustomException {
        pgdTzjhService.saveTzjhPgdXdBack(list,req);
        return new ResultBean();
    }



    @PostMapping("/saveTzjhPgdFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveTzjhPgdFk(HttpServletRequest req, @RequestBody List<PgdTzjh>list) throws Exception, CustomException {
        pgdTzjhService.saveTzjhPgdFk(list,req);
        return new ResultBean();
    }


    @PostMapping("/getPgdBase")
    @ResponseBody
    @AuthFunction
    public ResultBean getPgdBase(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
        Map returnMap = new HashMap();
        List<DmCbxxp> cbbm = dmCbxxpService.list(new QueryWrapper<DmCbxxp>().orderBy(true, true, "wgbs","cbbm","len(cbbm)"));
        // 班组人员
        List<EmSbjgry> gxry = emSbjgryService.list();
        List<Map> bmbm = syService.em_sbjbb_ZM("bmbm");
        // 多为
        List<DmDwxxp> dwxxs = dwxxpService.list();
        List<DmDwxxp> qys = dwxxpService.list(new QueryWrapper<DmDwxxp>().select("DISTINCT qy as  qy "));
        returnMap.put("qys", qys);
        returnMap.put("dwxxs", dwxxs);
        returnMap.put("dwxxs1", dwxxs);


        List<Ycldw> ycldws = ycldwService.ycldwList("ycl");
        returnMap.put("cbbm", cbbm);
        returnMap.put("gxry", gxry);
        returnMap.put("ycldws", ycldws);
        returnMap.put("bmbm", bmbm);

        List<Dm_zhbmp> qgkws1 = dm_zhbmpRepository.findByBMLB("QGKW");
        List<Dm_zhbmp>qgkws=new ArrayList<>();
        for (Dm_zhbmp qgkw : qgkws1) {
            if(qgkw.getBmsm().equals("1") || qgkw.getBmsm().equals("2")|| qgkw.getBmsm().equals("3")||qgkw.getBmsm().equals("4") ){
                continue;
            }
            qgkws.add(qgkw);
        }
        List<Dm_zhbmp> zylxs = dm_zhbmpRepository.findByBMLB("zylx");
        List<Dm_zhbmp> pwwzs = dm_zhbmpRepository.findByBMLB("pwwz");
        List<Dm_zhbmp> dhql = dm_zhbmpRepository.findByBMLB("DHQL");

        List<DmBzry> resourcesCodes = dmBzryService.list(new QueryWrapper<DmBzry>().select("DISTINCT zyq as  zyq ")
            .eq("flag_status", "1").in("zyq","二区","三区","四区","五区").orderBy(true,true,"zyq"));


        List<DmBzry> zyqs = dmBzryService.list(new QueryWrapper<DmBzry>().select(" resources_code","zyq")
            .eq("flag_status", "1").ne("isnull(resources_code,'')","").groupBy("resources_code","zyq").orderBy(true,true,"resources_code"));

        List<DmBzry> zyrys= dmBzryService.list(new QueryWrapper<DmBzry>()
            .eq("flag_status", "1").ne("isnull(zyq,'')","").in("zyq","二区","三区","四区","五区").orderBy(true,true,"zyq"));
        List<Dm_zhbmp> kwxxs = dm_zhbmpRepository.findByBMLB("PBBM");






        returnMap.put("resourcesCodes",resourcesCodes);
        returnMap.put("zyqs",zyqs);
        returnMap.put("zyrys",zyrys);
        returnMap.put("qgkw", qgkws);
        returnMap.put("zylx", zylxs);
        returnMap.put("pwwz", pwwzs);
        returnMap.put("dhql", dhql);
        /// zylx 流向   pwwz 抛丸位置   // QGKW  切割跨位

        return new ResultBean(returnMap);
    }


    @PostMapping("/getPgdBase1")
    @ResponseBody
    @AuthFunction
    public ResultBean getPgdBase1(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
        Map returnMap = new HashMap();
        List<DmCbxxp> cbbm = dmCbxxpService.list(new QueryWrapper<DmCbxxp>().orderBy(true, true, "wgbs","cbbm","len(cbbm)"));
        // 班组人员
        List<EmSbjgry> gxry = emSbjgryService.list();
        List<Map> bmbm = syService.em_sbjbb_ZM("bmbm");
        // 多为
        List<DmDwxxp> dwxxs = dwxxpService.list();
        List<DmDwxxp> qys = dwxxpService.list(new QueryWrapper<DmDwxxp>().select("DISTINCT qy as  qy "));
        returnMap.put("qys", qys);
        returnMap.put("dwxxs", dwxxs);
        returnMap.put("dwxxs1", dwxxs);


        List<Ycldw> ycldws = ycldwService.ycldwList("ycl");
        returnMap.put("cbbm", cbbm);
        returnMap.put("gxry", gxry);
        returnMap.put("ycldws", ycldws);
        returnMap.put("bmbm", bmbm);

        List<Dm_zhbmp> qgkws1 = dm_zhbmpRepository.findByBMLB("QGKW");
        List<Dm_zhbmp>qgkws=new ArrayList<>();
        for (Dm_zhbmp qgkw : qgkws1) {
            if(qgkw.getBmsm().equals("1") || qgkw.getBmsm().equals("2")|| qgkw.getBmsm().equals("3")||qgkw.getBmsm().equals("4") ){
                continue;
            }
            qgkws.add(qgkw);
        }
        List<Dm_zhbmp> zylxs = dm_zhbmpRepository.findByBMLB("zylx");
        List<Dm_zhbmp> pwwzs = dm_zhbmpRepository.findByBMLB("pwwz");
        List<Dm_zhbmp> dhql = dm_zhbmpRepository.findByBMLB("DHQL");

        List<DmBzry> resourcesCodes = dmBzryService.list(new QueryWrapper<DmBzry>().select("DISTINCT zyq as  zyq ")
                .eq("flag_status", "1").in("zyq","一区").orderBy(true,true,"zyq"));


        List<DmBzry> zyqs = dmBzryService.list(new QueryWrapper<DmBzry>().select(" resources_code","zyq")
                .eq("flag_status", "1").in("zyq","一区").ne("isnull(resources_code,'')","").groupBy("resources_code","zyq").orderBy(true,true,"resources_code"));

        List<DmBzry> zyrys= dmBzryService.list(new QueryWrapper<DmBzry>()
                .eq("flag_status", "1").ne("isnull(zyq,'')","").in("zyq","一区").orderBy(true,true,"zyq"));
        List<Dm_zhbmp> kwxxs = dm_zhbmpRepository.findByBMLB("PBBM");






        returnMap.put("resourcesCodes",resourcesCodes);
        returnMap.put("zyqs",zyqs);
        returnMap.put("zyrys",zyrys);
        returnMap.put("qgkw", qgkws);
        returnMap.put("zylx", zylxs);
        returnMap.put("pwwz", pwwzs);
        returnMap.put("dhql", dhql);
        /// zylx 流向   pwwz 抛丸位置   // QGKW  切割跨位

        return new ResultBean(returnMap);
    }



}

